<?php
/**
	* 
	* Start 
	* Create Date: 17 Jun, 2016
	* This module file using for commmonly used method in all controller.
	* Created saravana kumar.
	* @see no link
	* Last Updated: 23 Jun, 2016
	* End
	* 
*/
	namespace App\Models;
	use CodeIgniter\Model;
	use Binance;
	// $api = new Binance\API($key,$secret,true);
	Class Strategythird extends Model {

		public function __construct(){
			$this->db = \Config\Database::connect();
			$this->common_model = model('CommonModel');
		}

		public function index(){
			
		}


		public function third_strategy(){

			$third_strategy_users = $this->db->table('trade_process')->select('uusersid')->where('strategy_mode','3')->distinct()->where('trade_status','1')->get()->getResult();

			if ($third_strategy_users) {
				
				$i=0;
				foreach ($third_strategy_users as $key => $value) {
					$userid[$i] = $value->uusersid;
					$i++;
				}
                $db = db_connect();
				$admin_settings = $db->table('adminsettings')->orderBy('id','DESC')->get()->getRow();
			    $fuel_fee_percent = $admin_settings->min_fuel_fee;
			    echo"<pre>";
			    print_r($fuel_fee_percent);
			    echo"</pre>";

				// $userid[0] = 158;

				// $userid = explode(',', $userid);

				// $userid = array_filter($userid);

				for ($i=0; $i < count($userid); $i++) { 

					$userid_bind_process = $this->db->table('bind_process')->where('uusersid',$userid[$i])->get()->getRow();

					$trade_process_array = $this->db->table('trade_process')->where('uusersid',$userid[$i])->where('trade_status','1')->where('strategy_mode','3')->get()->getResult();

					

					for ($j=0;  $j < count($trade_process_array); $j++) { 

						$trade_process = $trade_process_array[$j];
	                if ($userid_bind_process && $trade_process && $trade_process->trade_status == '1') {
						$key = $userid_bind_process->api_key;
						$secret = $userid_bind_process->secret_key;
					    $api = new Binance\API($key,$secret);

					$ticker = $api->prices($trade_process->pair); // Make sure you have an updated ticker object for this to work
					
					$trade_where = array(
						'uuserid' => $userid[$i],
						'type !=' => '3',
						'trade_process_id' => $trade_process->id,
					);

					$last_buy = $this->db->table('api_trade_history')->where($trade_where)->orderBy('id','DESC')->get()->getRow();

				
					$last_buy_live_price = $last_buy->live_price;

					$live_price =  $ticker[$trade_process->pair];
					$ticks = $api->candlesticks($trade_process->pair, "15m");
					$res = end($ticks);
					$previous_high_price = $res['close'];
					// $live_price = '398';
					print_r("last buy ".$last_buy_live_price);
					echo "<br>";
					print_r("current live ".$live_price);
					// exit();

					if ($last_buy_live_price > $live_price) {

								// normal margin call drop buy function
               if($last_buy->type == 1)  {  
                    $trade_where_new = array(
						'uuserid' => $userid[$i],
						'type' => '1',
						'status' => 0,
						'trade_process_id' => $trade_process->id,
					);


      $last_buy_recheck = $this->db->table('api_trade_history')->where($trade_where_new)->orderBy('margin_call_drops','DESC')->get()->getRow();
       $last_margin_call_drop = $last_buy_recheck->margin_call_drops;
       if($last_margin_call_drop == 0){
       	 $number_of_margincall = 1;
       }else{
       	$number_of_margincall = $last_margin_call_drop;
       } 	
						$margin_call_drop = $trade_process->margincall_drop;
						$explode_margin_call_drop = explode(',', $margin_call_drop);
						$exploded = array_combine(range(1, count($explode_margin_call_drop)), $explode_margin_call_drop);
						$old_price = '';

					echo"<pre>";
					print_r($exploded);
					echo"</pre>";
					
         
						for ($k=1; $k<=count($exploded); $k++) {

					        $last_buy = $this->db->table('api_trade_history')->where($trade_where)->orderBy('id','DESC')->get()->getRow();
							if ($old_price == '') {
								$old_price = $last_buy->live_price;
							}

							$call_drop_where = array(
								'trade_process_id' => $trade_process->id,
								'uuserid' => $userid[$i],
								'margin_call_drops' => $k,
								'type' => 1,
								'status' => 0
							);

							$call_drop_where1 = array(
								'trade_process_id' => $trade_process->id,
								'uuserid' => $userid[$i],
								'type' => 2,
								'margin_call_drops' => $k,
								'status' => 0
							);


							$call_drop = $this->db->table('api_trade_history')->where($call_drop_where)->get()->getRow();
						
							

							if($k > 5){
								if($call_drop != ""){
                                      $call_drop_new = $this->db->table('api_trade_history')->where($call_drop_where1)->get()->getRow();
                                      if($call_drop_new){
                                      	$call_drop = "";
                                      }else{
                                      	$call_drop = true;
                                      }
                                     
                            echo"<pre>";
							echo "second<br>";
							print_r($k." ".$call_drop);
							echo"</pre>";
								}
							}
							
							
                 			if (!$call_drop) {
								$check_percentage = ($old_price - $live_price) / $old_price * 100;
								echo"<pre>";
								print_r("Old price".$old_price);
								print_r("Current Down".$check_percentage);
								print_r("Next call percentage".$k." :".$exploded[$k]);
								echo"</pre>";

								if ($check_percentage >= $exploded[$k]) {

									$explode_buyin_ratio_times = explode(',', $trade_process->buyin_ratio_times);
									$exploded_buy_ratio = array_combine(range(1, count($explode_buyin_ratio_times)), $explode_buyin_ratio_times);

									if($trade_process->open_position_doubled != 'on' || $trade_process->open_position_doubled == '')
										$quantity = 1;
									else
										$quantity = 2;
									$price = $trade_process->first_buy_amount * $quantity;

									$quantity = $price * $exploded_buy_ratio[$k];

									if ($trade_process->margin_call == '1' ) {
										// echo"<pre>";
										// print_r("hello");
										// echo"</pre>";
										// die;
									$buy_done = $this->marketbuy($userid[$i],$trade_process->id,$quantity,$k,$api,$trade_process->pair);
										$call_drop_where1 = array(
										'trade_process_id' => $trade_process->id,
										'uuserid' => $userid[$i],
										// 'margin_call_drops' => $k
										);
								
								$call_drop = $this->db->table('api_trade_history')->where($call_drop_where1)->orderBy('id','DESC')->get()->getRow();

								$old_price = $call_drop->live_price;
					
									}
								}
                            break;
							}else{

								$call_drop_where1 = array(
									'trade_process_id' => $trade_process->id,
									'uuserid' => $userid[$i],
									// 'margin_call_drops' => $k
								);
								
								$call_drop = $this->db->table('api_trade_history')->where($call_drop_where1)->orderBy('id','DESC')->get()->getRow();

								$old_price = $call_drop->live_price;
							}
						if($buy_done)
						break;
						}

					}
				else if($last_buy->type == 2){
					 $trade = $this->db->table('trade_process')->where("id",$trade_process->id)->get()->getRow();
					 echo"<pre>";
					 print_r("previous_high_price ".$previous_high_price);
					 print_r("live_price ".$live_price);
					 echo"</pre>";
					 
			        if($previous_high_price < $live_price && $trade->flag_buy != 1){
                  	$sell_record_update = $this->db->table('trade_process')->set('flag_buy','1')->where("id",$trade_process->id)->update();
                  		$buy_in_callback_temp = $live_price * $trade_process->buyin_callback / 100;
					$buy_in_callback_temp = $buy_in_callback_temp + $live_price;
					$sell_record_update1 = $this->db->table('trade_process')->set('buy_limit',$buy_in_callback_temp)->where("id",$trade_process->id)->update();
                  	}else if($previous_high_price < $live_price && $trade->flag_buy == 1 && $live_price < $trade->buy_limit){
                  	$sell_record_update = $this->db->table('trade_process')->set('flag_buy','1')->where("id",$trade_process->id)->update();
                  		$buy_in_callback_temp = $live_price * $trade_process->buyin_callback / 100;
					$buy_in_callback_temp = $buy_in_callback_temp + $live_price;
					$sell_record_update1 = $this->db->table('trade_process')->set('buy_limit',$buy_in_callback_temp)->where("id",$trade_process->id)->update();
                  	}

					 $trade = $this->db->table('trade_process')->where("id",$trade_process->id)->get()->getRow();
                  	 
                  	  echo"<pre>";
                  	  print_r($trade);
                  	  echo"</pre>";
                  	  // exit();
                  	


                  	if($trade->flag_buy == 1) {

                  	$buy_in_callback_temp = $trade->buy_limit;

					echo"<pre>";
					print_r("buy in call back price".$buy_in_callback_temp);
					echo"</pre>";

					if($buy_in_callback_temp <= $live_price){

						if($trade_process->open_position_doubled != 'on' || $trade_process->open_position_doubled == ''){
								$quantity = 1;
						}
						else
						{
								$quantity = 2;
						}
								$price = $trade_process->first_buy_amount * $quantity;
								$quantity = $price ;

								echo"<pre>";
								print_r($exploded_buy_ratio[$k]);
								echo "\n";
								print_r($quantity);
								echo "\n";
								print_r($trade_process->margin_call);
								echo"</pre>";
								// exit();

								$ticker = $api->prices(); // Make sure you have an updated ticker object for this to work
								$balances = $api->balances($ticker);
								$total_asset = $balances['USDT']['available'];
								$k = "";

										if($quantity >= 11 && $total_asset > $quantity)
										$buy_result = $this->marketbuy($userid[$i],$trade_process->id,$quantity,$k,$api,$trade_process->pair);
										$call_drop_where1 = array(
										'trade_process_id' => $trade_process->id,
										'uuserid' => $userid[$i],
										// 'margin_call_drops' => $k
										);
								
								$call_drop = $this->db->table('api_trade_history')->where($call_drop_where1)->orderBy('id','DESC')->get()->getRow();

								$old_price = $call_drop->live_price;
								
					            }
                  	}
				}
					}

					else{


					if($last_buy->type == 2){  //after take profit call market up buyincallback call
					$buy_in_callback_temp = $last_buy->live_price * $trade_process->buyin_callback / 100;
					$buy_in_callback_temp = $buy_in_callback_temp + $last_buy->live_price;

		 $buy_record_update1 = $this->db->table('trade_process')->set('flag_buy','0')->where("id",$trade_process_id)->update();
         $buy_record_update2 = $this->db->table('trade_process')->set('buy_limit','')->where("id",$trade_process_id)->update();

					echo"<pre>";
					print_r("sell ".$buy_in_callback_temp);
					print_r("live_price ".$live_price);
					echo"</pre>";

					if($buy_in_callback_temp <= $live_price){

						if($trade_process->open_position_doubled != 'on' || $trade_process->open_position_doubled == '')
								$quantity = 1;
						else
								$quantity = 2;
								$price = $trade_process->first_buy_amount * $quantity;
								$quantity = $price ;

								echo"<pre>";
								print_r($exploded_buy_ratio[$k]);
								echo "\n";
								print_r($quantity);
								echo "\n";
								print_r($trade_process->margin_call);
								echo"</pre>";
								// exit();

								$ticker = $api->prices(); // Make sure you have an updated ticker object for this to work
								$balances = $api->balances($ticker);
								$total_asset = $balances['USDT']['available'];

								echo"<pre>";
								print_r("profit buy");
								echo"</pre>";

								$k = "";
								

								if($quantity >= 11 && $total_asset > $quantity)
									$buy_result = $this->marketbuy($userid[$i],$trade_process->id,$quantity,$k,$api,$trade_process->pair);
										$call_drop_where1 = array(
										'trade_process_id' => $trade_process->id,
										'uuserid' => $userid[$i],
										// 'margin_call_drops' => $k
										);
								
								$call_drop = $this->db->table('api_trade_history')->where($call_drop_where1)->orderBy('id','DESC')->get()->getRow();

								$old_price = $call_drop->live_price;
								
								
					            }

				}
						else { 

						$trade_where = array(
							'uuserid' => $userid[$i],
							'type' => '1',
							'status' => 0,
							'trade_process_id ' => $trade_process->id,
							'margin_call_drops >= ' => '5'
						);

						$explode = explode(',', $trade_process->sub_position);


						$buy_records = $this->db->table('api_trade_history')->where($trade_where)->orderBy('id','DESC')->get()->getResult();

						$explode = array_reverse($explode);
						$m=0;
						foreach ($buy_records as $key => $value) {
						     $buy_records[$m] = $value;
						     $count1 = $value->margin_call_drops;
						     $count = $trade_process->margin_column_limit - $count1;
						     $buy_records[$m]->exploded = $explode[$count];
						     $m++;
						}

						echo"<pre>";
						print_r("sub position pending");
						print_r("<br>");
						print_r($buy_records);
						echo"</pre>";
                     // Subbin split (Margin call > 5)
                        if($buy_records) { 
						$l = 0;
						foreach ($buy_records as $key => $value) {
							
							if ($value->live_price > 0) {
								
								$avg_price = $value->live_price * $value->exploded / 100;

								$max_increase_price = $value->live_price + $avg_price ;

								$max_increase_price = round($max_increase_price,8);

								$max_down_percentage = $max_increase_price * $trade_process->sub_position_callback / 100;

								$max_down_price = $max_increase_price - $max_down_percentage;

								$max_down_price = round($max_down_price,8);

								// $avg_price = $live_price - $value->live_price;

								$avg_price = $value->quantity;

                      
                                $trade = $this->db->table('trade_process')->where("id",$trade_process->id)->get()->getRow();

                                echo"<pre>";
                                print_r("Sub position buyed live price".$value->live_price);
                                print_r("Max INcrease".$max_increase_price);
                                echo"</pre>";

                            
                            if ($live_price >= $max_increase_price && $trade->flag != 1) {
                            	$sell_record_update = $this->db->table('trade_process')->set('flag','1')->where("id",$trade_process->id)->update();
                            	$sell_record_update1 = $this->db->table('trade_process')->set('sell_limit',$max_down_price)->where("id",$trade_process->id)->update();
                            }

                        $trade = $this->db->table('trade_process')->where("id",$trade_process->id)->get()->getRow();


                        echo"<pre>";
                        print_r($trade);
                        echo"</pre>";
                        // die;

                      
                     

							if ($trade->flag == 1) {

								$trade_where = array(
									'uuserid' => $userid[$i],
									'type' => '1',
									'status' => 0,
									'trade_process_id' => $trade_process->id,
								);


		                        $buyed_quantity = $this->db->table('api_trade_history')->selectSum('received_amount')->where($trade_where)->orderBy('id','DESC')->get()->getRow();

								
								
								$quantity = number_format($value->received_amount,8);
								$price = $max_increase_price; // Try to sell it for 0.5 btc
								$stopPrice = $trade->sell_limit; // Sell immediately if price goes below 0.4 btc
								// $quantity = 0.07;

								echo"<pre>";
								print_r("MAX ".$max_increase_price);
								print_r("LIVE PRICE ".$live_price);
								print_r("MAX DOWN  ".$max_down_price);
								echo"</pre>";
								// exit();
								$ticker = $api->prices(); // Make sure you have an updated ticker object for this to work
								$balances = $api->balances($ticker);
								$total_asset = $balances[substr($trade->pair,0,-4)]['available'];

							    $k = $value->margin_call_drops;
							
								
									if($trade->sell_limit == $live_price){
									if(!empty($quantity) && $total_asset >= $quantity)
									$result1 = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$avg_price,1,$k);
									else
									$result = 0;
									} else if($live_price > $value->live_price && $trade->sell_limit <= $live_price){
									if(!empty($quantity) && $total_asset >= $quantity)
									$result1 = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$avg_price,1,$k);
									else
									$result = 0;
									} else if(!empty($trade_process->oneshot_limit) && $trade_process->oneshot_limit != 0){   // one shot hit new feature
                                    if($trade_process->oneshot_limit >= $live_price){
									if(!empty($quantity) && $total_asset >= $quantity)
								           $result_oneshothit = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$avg_price,1);
								    else
								    	$result_oneshothit = 0;

								   if($result_oneshothit){
								    	$buy_record_update = $this->db->table('api_trade_history')->set('status','1')->where($trade_where)->update();
								      $this->db->table('trade_process')->set('trade_status','2')->where('id',$trade_process->id)->update();
								      break;
								    }
								}
                        }else{

                        	if($live_price > $trade_process->sell_limit && $previous_high_price > $live_price){
                                 if(!empty($quantity) && $total_asset >= $quantity)
								           $result1 = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$avg_price,1,$k);
								    else
								    	$result = 0;
                        	}

                        }
                        if($result1)
                        $buy_record_update = $this->db->table('api_trade_history')->set('status','1')->where('id',$value->id)->update();
									// $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$stopPrice,$api,$trade_process->pair,$avg_price);
						if($result){
							
									$buy_record_update = $this->db->table('api_trade_history')->set('status','1')->where('id',$value->id)->update();

									$margin_call_drop = $trade_process->margincall_drop;

									$explode_margin_call_drop = explode(',', $margin_call_drop);
									$exploded = array_combine(range(1, count($explode_margin_call_drop)), $explode_margin_call_drop);

									$last_call_drop = array_key_last($exploded);

									$call_drop_where = array(
										'trade_process_id' => $trade_process->id,
										'uuserid' => $userid[$i],
										'margin_call_drops' => $last_call_drop
									);

									$call_drop_check = $this->db->table('api_trade_history')->where($call_drop_where)->get()->getRow();

									// if ($call_drop_check != '') {
									// 	$this->db->table('trade_process')->set('trade_status','2')->where('id',$trade_process->id)->update();	
									// }
									}
								}

							}

							$l++;

						}
					}else{
						// Full warehouse part split (Margin call 1 to 4)
						$margins = ['NULL','1','2','3','4'];
						
						$trade_where = array(
							'uuserid' => $userid[$i],
							'type' => '1',
							'status' => 0,
							'trade_process_id' => $trade_process->id,
							'margin_call_drops <=' => 4 
						);

						$buy_records1 = $this->db->table('api_trade_history')->selectSum('quantity')->where($trade_where)->orderBy('id','DESC')->get()->getRow();
						$buy_records2 = $this->db->table('api_trade_history')->selectSum('received_amount')->where($trade_where)->orderBy('id','DESC')->get()->getRow();


						if(!empty($buy_records1->quantity) && !empty($buy_records2->received_amount)){
						    $buy_records = $buy_records1->quantity / $buy_records2->received_amount;
                        }
					    else
					    	$buy_records = 0;

						if ($buy_records > 0  && $buy_records != '') {

							$avg_price = $buy_records * $trade_process->whole_profit_ratio / 100;

							$max_increase_price = $buy_records + $avg_price ;

							$max_increase_price = round($max_increase_price,8);

							$max_down_percentage = $max_increase_price * $trade_process->whole_profit_callback / 100;

							$max_down_price = $max_increase_price - $max_down_percentage;

							$max_down_price = round($max_down_price,8);

								echo"<pre>";
								print_r("MAX UP".$max_increase_price);
								print_r("MAX DOWN  ".$max_down_price);
								echo"</pre>";
                            
                         $trade = $this->db->table('trade_process')->where("id",$trade_process->id)->get()->getRow();

                            
                            if ($live_price >= $max_increase_price && $trade->flag != 1) {
                            	$sell_record_update = $this->db->table('trade_process')->set('flag','1')->where("id",$trade_process->id)->update();
                            	$sell_record_update1 = $this->db->table('trade_process')->set('sell_limit',$max_down_price)->where("id",$trade_process->id)->update();
                            }

                        $trade = $this->db->table('trade_process')->where("id",$trade_process->id)->get()->getRow();


                        echo"<pre>";
                        print_r($trade);
                        echo"</pre>";
                        // die;

                     

							if ($trade->flag == 1) {

								$trade_where = array(
									'uuserid' => $userid[$i],
									'type' => '1',
									'status' => 0,
									'trade_process_id' => $trade_process->id,
								);


		$buyed_quantity = $this->db->table('api_trade_history')->selectSum('received_amount')->where($trade_where)->orderBy('id','DESC')->get()->getRow();
         
								
								
								$quantity = number_format($buy_records2->received_amount,8);
								$price = $max_increase_price; // Try to sell it for 0.5 btc
								$stopPrice = $trade->sell_limit; // Sell immediately if price goes below 0.4 btc
								// $quantity = 0.07;

								echo"<pre>";
								print_r("MAX ".$max_increase_price);
								print_r("LIVE PRICE ".$live_price);
								print_r("MAX DOWN  ".$max_down_price);
								print_r("AVG PRICE  ".$avg_price);
								echo"</pre>";
								// exit();
								$ticker = $api->prices(); // Make sure you have an updated ticker object for this to work
								$balances = $api->balances($ticker);
								$total_asset = $balances[substr($trade->pair,0,-4)]['available'];

								
							
								
								if($trade->sell_limit == $live_price){
									if(!empty($quantity) && $total_asset >= $quantity)
								           $result = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$buy_records1,0);
								    else
								    	$result = 0;
								} else if($live_price > $avg_price && $trade->sell_limit <= $live_price){
									echo"<pre>";
									print_r($quantity);
									echo "<br>";
									print_r($total_asset);
									echo"</pre>";
									
									if(!empty($quantity) && $total_asset >= $quantity)
                                        $result = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$buy_records1,0);
                                    else
                                    	$result = 0;

                                    echo"<pre>";
                                    print_r($result);
                                    echo"</pre>";
					            } else if(!empty($trade_process->oneshot_limit) && $trade_process->oneshot_limit != 0){   // one shot hit new feature
                                    if($trade_process->oneshot_limit >= $live_price){
									if(!empty($quantity) && $total_asset >= $quantity)
								           $result_oneshothit = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$buy_records1,0);
								    else
								    	$result_oneshothit = 0;

								   if($result_oneshothit){
								    	$buy_record_update = $this->db->table('api_trade_history')->set('status','1')->where($trade_where)->update();
								      $this->db->table('trade_process')->set('trade_status','2')->where('id',$trade_process->id)->update();
								      break;
								    }
								}
                        }else{

                        	if($live_price > $trade_process->sell_limit && $previous_high_price > $live_price){
                        		echo"<pre>";
									print_r("condition 3 ");
									echo"</pre>";
                                 if(!empty($quantity) && $total_asset >= $quantity)
								           $result = $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$live_price,$api,$trade_process->pair,$buy_records1,0);
								    else
								    	$result = 0;
                        	}

                        }
								

								// $this->take_profit($userid[$i],$trade_process->id,$quantity,$price,$stopPrice,$api,$trade_process->pair,$buy_records);

								if($result){
										$buy_record_update = $this->db->table('api_trade_history')->set('status','1')->where($trade_where)->update();

								// check one shot strategy

								if ($trade_process->strategy_type != 'Cycle Strategy') {
									
									$this->db->table('trade_process')->set('trade_status','2')->where('id',$trade_process->id)->update();
								}

								/// check last call drop 

								$margin_call_drop = $trade_process->margincall_drop;

								$explode_margin_call_drop = explode(',', $margin_call_drop);
								$exploded = array_combine(range(1, count($explode_margin_call_drop)), $explode_margin_call_drop);

								$last_call_drop = array_key_last($exploded);

								$call_drop_where = array(
									'trade_process_id' => $trade_process->id,
									'uuserid' => $userid[$i],
									'margin_call_drops' => $last_call_drop
								);

								$call_drop_check = $this->db->table('api_trade_history')->where($call_drop_where)->get()->getRow();

								if ($call_drop_check != '') {
									$this->db->table('trade_process')->set('trade_status','2')->where('id',$trade_process->id)->update();	
								}
							}

								// return true;
							}
						}
					}
					}
					}
				}
			}
		}
	}

}




// public function marketbuy($userid,$trade_process_id,$quantity,$margin_call_drops,$api,$pair){

// 		// print_r($api);
// 		// exit();

// 	$flags['isQuoteOrder'] = true;
// 				// $order = $api->buy("BNBUSDT", "10",0,"MARKET",$flags);
// 				// $order = $api->marketQuoteSell("BNBUSDT", "100",$flags);
// 	$order = $api->marketQuoteBuy($pair, $quantity,$flags);

// 	$trade_process = $this->db->table('trade_process')->where('uusersid',$userid)->where('trade_status','1')->where('id',$trade_process_id)->get()->getRow();

// 	$order_history = array(
// 		'pair' => $order['symbol'],
// 		'order_id' => $order['orderId'],
// 		'trade_process_id' => $trade_process_id,
// 		'uuserid' => $userid,
// 		'type' => '1',
// 		'quantity' => $order['cummulativeQuoteQty'],
// 		' original_quantity' => $quantity,
// 		'time' => $order['transactTime'],
// 		'received_amount' => $order['executedQty'],
// 		'live_price' => $order['fills'][0]['price'],
// 		'margin_call_drops' => $margin_call_drops,
// 		'strategy_mode' => $trade_process->strategy_mode,
// 		'status' => 0,
// 	);

// 	$this->db->table('api_trade_history')->insert($order_history);

// 	return true;
// }

	public function marketbuy($userid,$trade_process_id,$quantity,$margin_call_drops,$api,$pair){

		// print_r($api);
		// exit();
        if($quantity <= 10){
        	$quantity = 11;
        }
		$flags['isQuoteOrder'] = true;

		$quantity = str_replace(',', '', $quantity);
				// $order = $api->buy("BNBUSDT", "10",0,"MARKET",$flags);
				// $order = $api->marketQuoteSell("BNBUSDT", "100",$flags);
		$order = $api->marketQuoteBuy($pair, $quantity,$flags);
		echo"<pre>";
		print_r($order);
		echo"</pre>";

		$trade_process = $this->db->table('trade_process')->where('uusersid',$userid)->where('trade_status','1')->where('id',$trade_process_id)->get()->getRow();

		$order_history = array(
			'pair' => $order['symbol'],
			'order_id' => $order['orderId'],
			'trade_process_id' => $trade_process_id,
			'uuserid' => $userid,
			'type' => '1',
			'quantity' => $order['cummulativeQuoteQty'],
			' original_quantity' => $quantity,
			'time' => $order['transactTime'],
			'received_amount' => $order['executedQty'],
			'live_price' => $order['fills'][0]['price'],
			'margin_call_drops' => $margin_call_drops,
			'date' => date('Y-m-d',time()),
			'strategy_mode' => $trade_process->strategy_mode,
			'status' => 0,
		);

		if($order){
			if($margin_call_drops >= 5)
			$buy_record_next = $this->db->table('api_trade_history')->set('status','1')->where("id",$trade_process_id)->where("type",2)->where("margin_call_drops",$margin_call_drops)->update();

		    $buy_record_update = $this->db->table('trade_process')->set('flag','0')->where("id",$trade_process_id)->update();
        	$buy_record_update_c1 = $this->db->table('trade_process')->set('flag_buy','0')->where("id",$trade_process_id)->update();
        	$buy_record_update_c2 = $this->db->table('trade_process')->set('sell_limit','')->where("id",$trade_process_id)->update();
        	$buy_record_update_c3 = $this->db->table('trade_process')->set('buy_limit','')->where("id",$trade_process_id)->update();
		}

		$this->db->table('api_trade_history')->insert($order_history);
		if($order){
			return true;
		}
		else{
			$duplicate_check = $this->db->table('notification_table')->where('uusersid',$userid)->like('message','Binance '.$pair)->like('created_date',date('Y-m-d'))->get()->getRow();
	    if(!$duplicate_check) { 
					$notification = array(
						'uusersid' => $userid, 
						'message'  => 'Binance '.$pair.' failed to cover short position due to insufficient exchange balance and has stopped opening short position. if you need to reopen short position, please go to the strategy details page of Open margin call',
						'created_date' => date('Y-m-d H:i:s')
		);
		$this->db->table('notification_table')->insert($notification);
	}
			return false;
		}
	}

public function marketsell($userid,$trade_process_id,$quantity,$margin_call_drops,$api,$pair){

	$flags['isQuoteOrder'] = true;

	$order = $api->marketQuoteSell($trade_process->pair,$quantity);

	$order_history = array(
		'pair' => $order['symbol'],
		'order_id' => $order['orderId'],
		'trade_process_id' => $trade_process_id,
		'uuserid' => $userid,
		'type' => '2',
		'quantity' => $order['cummulativeQuoteQty'],
		' original_quantity' => $quantity,
		'time' => $order['transactTime'],
		'received_amount' => $order['executedQty'],
		'live_price' => $order['fills'][0]['price'],
		'margin_call_drops' => $margin_call_drops
	);
	$this->db->table('api_trade_history')->insert($order_history);
	
if($order)
	return true;
else
	return false;
}


public function take_profit($userid,$trade_process_id,$quantity,$price,$stopPrice,$api,$pair,$avg_price,$subsell_status,$k=""){
	    $quantity = str_replace(',', '', $quantity);
		$exchange_info = $api->exchangeInfo();

    foreach ($exchange_info['symbols'] as $key => $value) {
      if( strcasecmp( $value['symbol'], $pair ) == 0){
        $stepsize = $value['filters'][2]['stepSize'];
      break;
      }
    }


$stepsize = fmod($stepsize, 1);
$total_no = str_replace('.', '', $stepsize);
$count = strlen($total_no) - 1;

// $stepsize = explode('.', $stepsize)[1];
 if($stepsize == 1.00000000)
 	$current = 0;
 else
    $current = $count+1;
	$quantity = number_format($quantity,$current);

		echo"<pre>";
		print_r("stepsize");
		echo "<br>";
		print_r($stepsize);
		echo "<br>";
		print_r($current);
		echo "<br>";
		print_r($quantity);
		echo"</pre>";
       
		// $order = $api->marketQuoteSell($pair,$quantity);
		$quantity = str_replace(',', '', $quantity);
		$order = $api->sell($pair,$quantity,0,"MARKET");

		echo "<pre>";
		print_r($order);
		echo "</pre>";
		

		// $order = $api->sell($pair, $quantity, $price, "TAKE_PROFIT_LIMIT", ["stopPrice"=>$stopPrice]);
		
        if($order) { 
        	$buy_record_update    = $this->db->table('trade_process')->set('flag','0')->where("id",$trade_process_id)->update();
        	$buy_record_update_c1 = $this->db->table('trade_process')->set('flag_buy','0')->where("id",$trade_process_id)->update();
        	$buy_record_update_c2 = $this->db->table('trade_process')->set('sell_limit','')->where("id",$trade_process_id)->update();
        	$buy_record_update_c3 = $this->db->table('trade_process')->set('buy_limit','')->where("id",$trade_process_id)->update();
		    $trade_process = $this->db->table('trade_process')->where('uusersid',$userid)->where('trade_status','1')->where('id',$trade_process_id)->get()->getRow();
		    $db = db_connect();
			$admin_settings = $db->table('adminsettings')->orderBy('id','DESC')->get()->getRow();
			$fuel_fee_percent = $admin_settings->min_fuel_fee;

         if($subsell_status != 1)
	     $avg_price1 = $order['cummulativeQuoteQty'] - $avg_price->quantity; 
	     else
	     $avg_price1 = $order['cummulativeQuoteQty'] - $avg_price; 
		 echo"<pre>";
		 print_r("avg_price 1");
		 echo "<br>";
		 print_r($avg_price1);
		 echo"</pre>";
	     $reverse_percent = 100 - $fuel_fee_percent;
	     $avg_price = $avg_price1 * ($reverse_percent / 100);
	     $comm_price = $avg_price1 * ($fuel_fee_percent / 100);
	     echo"<pre>";
	     print_r("avg price : ");
	     print_r($avg_price);
	     echo "<br>";
	     print_r("comm price");
	     print_r($comm_price);
	     echo"</pre>";
	     $profit1 = $avg_price / $order['cummulativeQuoteQty'];
	     $profit = $profit1 * 100;
		 $order_history = array(
			'pair' => $pair,
			'order_id' => $order['orderId'],
			'trade_process_id' => $trade_process_id,
			'uuserid' => $userid,
			'type' => '2',
			'quantity' => $order['cummulativeQuoteQty'],
			' original_quantity' => $order['cummulativeQuoteQty'],
			'time' => $order['transactTime'],
			'received_amount' => $order['executedQty'],
			'live_price' => $stopPrice,
			'avg_price' => $avg_price1,
			'comm_price' => $comm_price,
			'profit_percentage' => $profit,
			'date' => date('Y-m-d',time()),
			'margin_call_drops' => $k,
			'strategy_mode' => $trade_process->strategy_mode,
			'subsell_status' => $subsell_status,
			'status' => 0
		);	
		$this->db->table('api_trade_history')->insert($order_history);
		$deposit_data = array(           // fuel fee deduction
        'uusersid' => $userid,
        'amount'  => $comm_price,
        'depositid' => $this->db->InsertID(),
        'type'  => 'fuel', 
        'description'  => 'fuel fee deduction for order no '.$order['orderId'],
        'date'  => date('Y-m-d H:i:s'),
        'currency' => 1,
        'transactionid' => $trade_process_id
        );
		$this->db->table('history')->insert($deposit_data); 
		$return = true;
	}else{
		$duplicate_check = $this->db->table('notification_table')->where('uusersid',$userid)->like('message','Binance '.$pair)->like('created_date',date('Y-m-d'))->get()->getRow();
	    if(!$duplicate_check) { 
		$notification = array(
			'uusersid' => $userid, 
			'message'  => 'Binance '.$pair.' failed to cover short position due to insufficient exchange balance and has stopped opening short position. if you need to reopen short position, please go to the strategy details page of Open margin call',
			'created_date' => date('Y-m-d H:i:s')
		);
		$this->db->table('notification_table')->insert($notification);
	    }
		$return = false;
	}

		return $return;
	}

}